
/*
import 'package:async/async.dart';
import 'package:chobi_admob_flutter/chobi_admob.dart';
import 'package:flutter/cupertino.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:shared_preferences/shared_preferences.dart';



abstract class ChobiAdMobState<T extends ConsumerStatefulWidget> extends ConsumerState<T> {

  final isAdAvailable = StateProvider((ref) => false);
  final isAdLoaded = StateProvider((ref) => false);

  String get lastClickedPrefsKey;
  bool get isDebug;

  int get adIntervalMilliSec => 5 * 60 * 1000;
  List<String>? get testIds => null;

  CancelableOperation<bool>? _waitingOperation;

  //late final StateProvider<int> _adLastClickedTimeProvider;
  int _adLastClickedTime = 0;

  int get intervalWaitingTime => adIntervalMilliSec - (DateTime.now().millisecondsSinceEpoch - _adLastClickedTime);


  @protected
  void onConsentCheckFinished(ConsentStatus status) {}

  @protected
  void onConsentCheckError(FormError error) {}


  void resetConsentStatus() {
    ConsentInformation.instance.reset();
  }




  void _innerCheckProcess() {
    final params = ChobiAdMob.createConsentRequestParameters(
      isDebug: isDebug,
      testIds: testIds,
    );

    ChobiAdMob.simpleCheckAndLoadForm(
      params: params,
      onCheckedStatus: onConsentCheckFinished,
      onError: onConsentCheckError,
    );
  }

  Future<int> updateAdLastClickedTime() async {
    final time = DateTime.now().millisecondsSinceEpoch;
    _adLastClickedTime = time;
    final prefs = await SharedPreferences.getInstance();
    await prefs.setInt(lastClickedPrefsKey, time);
    return time;
  }

  Future<void> startAdProcess({Future<void> Function()? onBeforeStartProcess, }) async {

    final waitingMs = intervalWaitingTime;

    await onBeforeStartProcess?.call();

    if (waitingMs <= 0) {
      _innerCheckProcess();
    } else {
      await _waitingOperation?.cancel();
      _waitingOperation = CancelableOperation.fromFuture(
        Future.delayed(Duration(milliseconds: waitingMs), () {
          return true;
        }),
        onCancel: () {
          _waitingOperation = null;
        },
      );
      _waitingOperation?.value.then((value) {
        _waitingOperation = null;
        startAdProcess(onBeforeStartProcess: onBeforeStartProcess);
      });
    }
  }


  @override
  void initState() {
    super.initState();

    ChobiAdMob
        .loadLastClickedTimeFromPrefs(prefKey: lastClickedPrefsKey)
        .then((value) {
          //_adLastClickedTimeProvider = StateProvider((ref) => value);
      _adLastClickedTime = value;
    });
  }

  @override
  void dispose() {
    _waitingOperation?.cancel();

    super.dispose();
  }

}
*/
