#ifndef FLUTTER_PLUGIN_CHOBI_ADMOB_FLUTTER_PLUGIN_H_
#define FLUTTER_PLUGIN_CHOBI_ADMOB_FLUTTER_PLUGIN_H_

#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>

#include <memory>

namespace chobi_admob_flutter {

class ChobiAdmobFlutterPlugin : public flutter::Plugin {
 public:
  static void RegisterWithRegistrar(flutter::PluginRegistrarWindows *registrar);

  ChobiAdmobFlutterPlugin();

  virtual ~ChobiAdmobFlutterPlugin();

  // Disallow copy and assign.
  ChobiAdmobFlutterPlugin(const ChobiAdmobFlutterPlugin&) = delete;
  ChobiAdmobFlutterPlugin& operator=(const ChobiAdmobFlutterPlugin&) = delete;

  // Called when a method is called on this plugin's channel from Dart.
  void HandleMethodCall(
      const flutter::MethodCall<flutter::EncodableValue> &method_call,
      std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
};

}  // namespace chobi_admob_flutter

#endif  // FLUTTER_PLUGIN_CHOBI_ADMOB_FLUTTER_PLUGIN_H_
